"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Plus = void 0;
const Evaluator_js_1 = require("../Evaluator.js");
const Rule_js_1 = require("./Rule.js");
class Plus extends Rule_js_1.Rule {
    constructor(tgt, child) {
        super("plus", tgt, child);
        this.setEvaluator(Evaluator_js_1.Evaluator.ALL_CHILDREN_EVALUATOR);
    }
    getEntry() {
        return this.children[0];
    }
    createBNF(grammar) {
        const p1 = Rule_js_1.Rule.addProduction(grammar, this, this.tgt, this.children[0], this.tgt);
        const p2 = Rule_js_1.Rule.addProduction(grammar, this, this.tgt, this.children[0]);
        const that = this;
        p1.onExtension((parent, ...children) => {
            let nthEntry = parent.getNthEntryInParent();
            let c0 = children[0];
            let c1 = children[1];
            c0.setNthEntryInParent(nthEntry);
            c0.setName(that.getNameForChild(nthEntry));
            c1.setNthEntryInParent(nthEntry + 1);
            c1.setName(parent.getName());
        });
        p2.onExtension((parent, ...children) => {
            let nthEntry = parent.getNthEntryInParent();
            let c0 = children[0];
            c0.setNthEntryInParent(nthEntry);
            c0.setName(that.getNameForChild(nthEntry));
        });
        p1.setAstBuilder((parent, ...children) => {
            parent.addChildren(children[0]);
            parent.addChildren(...children[1].getChildren());
        });
        p2.setAstBuilder((parent, ...children) => {
            parent.addChildren(children[0]);
        });
    }
}
exports.Plus = Plus;
//# sourceMappingURL=Plus.js.map