import { Matcher } from "./Matcher.js";
import { Production } from "./Production.js";
import { Sym } from "./Symbol.js";
import { Autocompletion } from "./Autocompletion.js";
declare class DefaultParsedNode {
    private parent;
    private readonly children;
    private readonly symbol;
    private readonly production;
    private readonly matcher;
    private name;
    constructor(matcher: Matcher, symbol: Sym, production: Production | undefined);
    getSymbol(): Sym;
    getName(): string;
    setName(name: string | undefined): void;
    getProduction(): Production | undefined;
    getMatcher(): Matcher;
    doesAutocomplete(): boolean;
    getAutocompletion(_justCheck: boolean): Autocompletion[] | undefined;
    numChildren(): number;
    getChildren(): DefaultParsedNode[];
    getChild(index: number): DefaultParsedNode;
    getChild(name: string): DefaultParsedNode;
    addChildren(...children: DefaultParsedNode[]): void;
    getParent(): DefaultParsedNode | undefined;
    removeAllChildren(): void;
    evaluate(n: number): any;
    evaluate(...n: string[]): any;
    getParsedString(...names: string[]): string;
    toString(): string;
}
export { DefaultParsedNode };
//# sourceMappingURL=DefaultParsedNode.d.ts.map