import { Parser } from "../Parser.js";
import { Autocompletion } from "../core/Autocompletion.js";
import { EditorView } from "@codemirror/view";
export declare class ACEditor {
    private readonly editor;
    private readonly parser;
    private parameterizedCompletion?;
    private readonly errorHighlight?;
    private readonly outputElement;
    private readonly completer;
    private onRun;
    private beforeRun;
    private afterRun;
    constructor(parser: Parser, parent: HTMLElement);
    setText(text: string): void;
    getSelectedLinesStart(): number;
    getSelectedLinesEnd(): number;
    getSelectedLines(): string;
    setOnRun(onRun: () => void): void;
    setBeforeRun(beforeRun: () => void): void;
    setAfterRun(afterRun: () => void): void;
    private createEditorElement;
    private createOutputElement;
    private createButton;
    run(selectedLinesOnly?: boolean): void;
    private lastInsertionPosition;
    insertCompletion(completion: Autocompletion | undefined): void;
    parameterChanged(pIdx: number, wasLast: boolean): void;
    cancelParameterizedCompletion(): void;
    handleKeyEvent(e: KeyboardEvent, view: EditorView): boolean;
    autocomplete(autoinsertSingleOption?: boolean): void;
}
//# sourceMappingURL=ACEditor.d.ts.map